#define _GNU_SOURCE
#include <stdlib.h>
#include <stdint.h>
#include <sys/ioctl.h>
#include <sound/asound.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>

int main(void)
{
	struct snd_ctl_elem_info info = {};
	int ret;
	int fd;

	fd = open("/dev/snd/controlC0", 0);
	if (fd == -1) {
		perror("");
		exit(1);
	}

	memset(&info, 0x00, sizeof(info));
	info.type = SNDRV_CTL_ELEM_TYPE_BOOLEAN;
	info.count = 1;
	info.owner = 10;
	info.id.index = UINT_MAX - 5;
	info.access = SNDRV_CTL_ELEM_ACCESS_READWRITE |
		SNDRV_CTL_ELEM_ACCESS_TLV_READWRITE;

	sprintf(info.id.name, "Test Switch%d", rand() % 100);

	ret = ioctl(fd, SNDRV_CTL_IOCTL_ELEM_ADD, &info);
	if (ret == -1) {
		printf("Failed to add control: OK\n");
		return 0;
	}

	printf("Invalid control added\n");

	ret = ioctl(fd, SNDRV_CTL_IOCTL_ELEM_INFO, &info);
	if (ret == -1) {
		printf("\t ... and can't find the control anymore\n");
	} else {
		ioctl(fd, SNDRV_CTL_IOCTL_ELEM_REMOVE, &info);
	}

	return 0;
}
