#define _GNU_SOURCE
#include <stdlib.h>
#include <stdint.h>
#include <sys/ioctl.h>
#include <sound/asound.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <stdbool.h>

int main(void)
{
	int fd;
	int ret;
	struct snd_ctl_elem_info info = {};
	bool will_overflow = false;

	fd = open("/dev/snd/controlC0", 0);
	if (fd == -1) {
		perror("");
		exit(1);
	}

	memset(&info, 0x00, sizeof(info));
	info.type = SNDRV_CTL_ELEM_TYPE_BOOLEAN;
	info.count = 1;
	info.owner = 1028;
	info.access = SNDRV_CTL_ELEM_ACCESS_READWRITE |
		SNDRV_CTL_ELEM_ACCESS_TLV_READWRITE;

	sprintf(info.id.name, "Test Switch");

	ioctl(fd, SNDRV_CTL_IOCTL_ELEM_REMOVE, &info);

	ret = ioctl(fd, SNDRV_CTL_IOCTL_ELEM_ADD, &info);
	if (ret == -1) {
		perror("add");
		exit(1);
	}

	ret = ioctl(fd, SNDRV_CTL_IOCTL_ELEM_INFO, &info);
	if (ret == -1) {
		perror("info");
		exit(1);
	}

	printf("Trying to overflow numid, this may take a while. Current numid: %u\n", info.id.numid);

	while (1) {
		info.id.numid = 0;
		ret = ioctl(fd, SNDRV_CTL_IOCTL_ELEM_INFO, &info);
		if (ret == -1) {
			perror("info");
			exit(1);
		}

		if (will_overflow) {
			if (info.id.numid > UINT_MAX - 1028)
				printf("numid overflowed incorrectly: %u - %u\n", info.id.numid, info.id.numid + 1028);
			else
				printf("numid overflowed correctly: %u - %u\n", info.id.numid, info.id.numid + 1028);
			return 0;
		}

		if (info.id.numid + 1028 >= UINT_MAX - 1028) {
			will_overflow = true;
			printf("Next numid will overfolow: %u\n", info.id.numid);
		}

		info.owner = 1028;

		ret = ioctl(fd, SNDRV_CTL_IOCTL_ELEM_REPLACE, &info);
		if (ret == -1) {
			perror("replace");
			exit(1);
		}
	}

	return 0;
}
